Class | Chef::MinimalCookbookVersion
In: | lib/chef/cookbook_version.rb
Parent: | Object

## Chef::MinimalCookbookVersion

     MinimalCookbookVersion is a duck type of CookbookVersion, used
     internally by Chef Server as an optimization when determining the
     optimal cookbook set for a chef-client.

     MinimalCookbookVersion objects contain only enough information to
     solve the cookbook collection for a given run list. They *do not*
     contain enough information to generate the response.

     See also: Chef::CookbookVersionSelector

### Methods

<=> legit_version load_all load_full_versions_of metadata new

### Included Modules

Comparable

### Constants

ID | = | "id".freeze
NAME | = | 'name'.freeze
KEY | = | 'key'.freeze
VERSION | = | 'version'.freeze
VALUE | = | 'value'.freeze
DEPS | = | 'deps'.freeze
DEPENDENCIES | = | 'dependencies'.freeze

### Attributes

couchdb_id | [R] |
deps | [R] |
name | [R] |
version | [R] |

### Public Class methods

load_all(couchdb)

Loads the full list of cookbooks, using a couchdb view to fetch only the id, name, version, and dependency constraints. This is enough information to solve for the cookbook collection for a given run list. After solving for the cookbook collection, you need to call `load_full_versions_of` to convert MinimalCookbookVersion objects to their non-minimal counterparts

load_full_versions_of(minimal_cookbook_versions, couchdb)

Loads the non-minimal CookbookVersion objects corresponding to `minimal_cookbook_versions` from couchdb using a bulk GET.

new(params)

### Public Instance methods

<=>(o)
legit_version()
metadata()

Returns the Cookbook::MinimalMetadata object for this cookbook version.

[Validate]